SystemOrganization addCategory: #'IRDA2013-sorting2-Tests'!

TestCase subclass: #S2BubblesorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2BubblesorterTests methodsFor: 'iterating' stamp: 'AT 6/17/2013 18:52:41.569'!
testAbortFocusing1
| list iterator |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 2.
	list secondFocusedIndex: 3.
	iterator := S2BubblesortIterator newWithList: list.
	self assert: iterator abortFocusing not! !

!S2BubblesorterTests methodsFor: 'iterating' stamp: 'AT 6/17/2013 18:52:56.309'!
testAbortFocusing2
| list iterator |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 5.
	list secondFocusedIndex: 6.
	iterator := S2BubblesortIterator newWithList: list.
	self assert: iterator abortFocusing! !

!S2BubblesorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/17/2013 18:54:35.832'!
testCompareFocusedElements1
|evaluator list|
	list := S2List new.
	list setupList: #(3 1 2).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	evaluator := S2BubblesortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator compareFocusedElements.
	! !

!S2BubblesorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/17/2013 18:55:01.394'!
testCompareFocusedElements2
|evaluator list|
	list := S2List new.
	list setupList: #(1 2 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	evaluator := S2BubblesortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator compareFocusedElements not.
	! !

!S2BubblesorterTests methodsFor: 'list part finding' stamp: 'AT 6/24/2013 11:44:08.128'!
testFindLeftIndex1
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3) asOrderedCollection.
	list sortedIndices: #(3) asSortedCollection.
	finder := S2BubblesortSublistFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 1.! !

!S2BubblesorterTests methodsFor: 'list part finding' stamp: 'AT 6/24/2013 11:44:10.668'!
testFindLeftIndex2
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asOrderedCollection.
	list sortedIndices: #(1 2 3 4 5) asSortedCollection.
	finder := S2BubblesortSublistFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 1.! !

!S2BubblesorterTests methodsFor: 'list part finding' stamp: 'AT 6/24/2013 11:44:13.037'!
testFindLeftIndex3
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asOrderedCollection.
	list sortedIndices: #(2 3 4 5) asSortedCollection.
	finder := S2BubblesortSublistFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 1.! !

!S2BubblesorterTests methodsFor: 'list part finding' stamp: 'AT 6/24/2013 11:44:15.51'!
testFindRightIndex1
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asSortedCollection.
	list sortedIndices: #(5) asSortedCollection.
	finder := S2BubblesortSublistFinder newWithList: list.
	self assert: (finder findRightIndex) equals: 4! !

!S2BubblesorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:56:40.121'!
testInitSecondFocusedIndex
|finder list|
	list := S2List new.
	list setupList: #(3 1 6 4 7 2) asOrderedCollection.
	list leftBoundIndex: 1.
	list rightBoundIndex: 6.
	finder := S2BubblesortFocusedIndicesFinder newWithList: list.
	self assert: (finder initSecondFocusedIndex) equals: 2.! !

!S2BubblesorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:57:24.463'!
testNextFocus1
| finder list |
	list := S2List new.
	list setupList: #(2 5 0 3 4 1 6 3).
	list firstFocusedIndex: 2.
	list secondFocusedIndex: 3.
	finder := S2BubblesortFocusedIndicesFinder newWithList: list.
	finder nextFocusedElementsIndices.
	self assert: (list firstFocusedIndex) equals: 3.
	self assert: (list secondFocusedIndex) equals: 4.
	! !

!S2BubblesorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:57:53.599'!
testNextFocus2
| finder list |
	list := S2List new.
	list setupList: #(1 2).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	finder := S2BubblesortFocusedIndicesFinder newWithList: list.
	finder nextFocusedElementsIndices.
	self assert: (list firstFocusedIndex) equals: 2.
	self assert: (list secondFocusedIndex) equals: 3.
	! !

!S2BubblesorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:58:44.994'!
testShouldUpdateFirstFocusedIndex
| finder |
	finder := S2BubblesortFocusedIndicesFinder new.
	self assert: (finder shouldUpdateFirstFocusedIndex).
	! !

!S2BubblesorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:59:02.351'!
testShouldUpdateSecondFocusedIndex
| finder |
	finder := S2BubblesortFocusedIndicesFinder new.
	self assert: (finder shouldUpdateSecondFocusedIndex).
	! !

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:39:56.246'!
testSort
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #(2 5 8 2 6 4 8 2).
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:40:49.605'!
testSortAllEqual
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #(2 2 2) asOrderedCollection.
	sortedList := #(2 2 2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:41:06.671'!
testSortEmpty
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #() asOrderedCollection.
	sortedList := #() asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:41:27.804'!
testSortOne
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #(2) asOrderedCollection.
	sortedList := #(2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'list part sorting' stamp: 'AT 6/24/2013 11:44:34.901'!
testUpdateSortedIndices
	| list partSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list sortedIndices: #(5) asSortedCollection.
	list firstFocusedIndex: 4.
	partSorter := S2BubblesortSublistSorter newWithList: list.
	partSorter updateSortedIndices.
	self assert: (list sortedIndices) equals: (#(4 5) asSortedCollection).! !

TestCase subclass: #S2ListTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 11:52:19.378'!
testActivatePartition
	| list |
	list := S2List new.
	list setupList: #(1 2 3 4) asOrderedCollection.
	list partitionIndices: #(#(1 2) #(3 4)) asOrderedCollection.
	list activePartitions: #(1) asOrderedCollection.
	list activatePartition: 2.
	self assert: (list activePartitions) equals: #(1 2) asOrderedCollection.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:57:59.3'!
testAddElementAsSorted
	| expected list |
	list := S2List new.
	list sortedIndices: #(3 2) asSortedCollection.
	expected := #(4 3 2) asSortedCollection.
	list addIndexAsSorted: 4.
	self assert: (list sortedIndices) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 14:32:00.913'!
testAddElementIndexToOutOfPlaceList
	| list |
	list := S2List new.
	list setupList: #(7 4 2 0) asOrderedCollection.
	list partitionIndices: #() asOrderedCollection.
	list partitionIndices add: #(1 2) asOrderedCollection.
	list partitionIndices add: #(3 4) asOrderedCollection.
	list addElementIndexToOutOfPlaceList: 3.
	self assert: (list outOfPlaceList) equals: #(2) asOrderedCollection.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 11:52:24.42'!
testDeactivatePartition
	| list |
	list := S2List new.
	list setupList: #(1 2 3 4) asOrderedCollection.
	list partitionIndices: #(#(1 2) #(3 4)) asOrderedCollection.
	list activePartitions: #(1) asOrderedCollection.
	list deactivatePartition: 1.
	self assert: (list activePartitions) equals: #() asOrderedCollection.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:30:22.982'!
testInsertPivotAt1
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 7.
	expected := #(3 7 1 2 0 8 0 2) asOrderedCollection.
	list insertPivotAt: 3.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:21:25.101'!
testInsertPivotAt2
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 8.
	expected := #(2 3 7 2 0 8 0 1) asOrderedCollection.
	list insertPivotAt: 1.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:28:50.913'!
testInsertPivotAt3
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 4.
	expected := #(3 7 2 8 0 0 1 2) asOrderedCollection.
	list insertPivotAt: 7.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 19:25:35.429'!
testInsertPivotAt4
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 4.
	expected := #(3 7 2 0 8 0 1 2) asOrderedCollection.
	list insertPivotAt: 4.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 16:52:16.821'!
testMergeBackTmpList
	| list expected |
	list := S2List new.
	list setupList: #(nil nil 2 0) asOrderedCollection.
	list partitionIndices: #() asOrderedCollection.
	list partitionIndices add: #() asOrderedCollection.
	list partitionIndices add: #() asOrderedCollection.
	list partitionIndices add: #(3)asOrderedCollection.
	list partitionIndices add: #(4) asOrderedCollection.
	list outOfPlaceList: #(7 4) asOrderedCollection.
	list mergeBackTmpList.
	expected := #() asOrderedCollection.
	expected add: #(1 2) asOrderedCollection.
	expected add: #(3) asOrderedCollection.
	expected add: #(4) asOrderedCollection.
	self assert: (list elements) equals: #(7 4 2 0) asOrderedCollection.
	self assert: (list partitionIndices) equals: expected.
	self assert: (list outOfPlaceList) equals: #() asOrderedCollection. ! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 16:59:45.413'!
testMergeBackTmpList2
	| list expected |
	list := S2List new.
	list setupList: #(nil nil nil nil 2 0) asOrderedCollection.
	list partitionIndices: #() asOrderedCollection.
	list partitionIndices add: #() asOrderedCollection.
	list partitionIndices add: #() asOrderedCollection.
	list partitionIndices add: #(5)asOrderedCollection.
	list partitionIndices add: #(6) asOrderedCollection.
	list outOfPlaceList: #(7 4 4 1) asOrderedCollection.
	list mergeBackTmpList.
	expected := #() asOrderedCollection.
	expected add: #(1 2 3 4) asOrderedCollection.
	expected add: #(5) asOrderedCollection.
	expected add: #(6) asOrderedCollection.
	self assert: (list elements) equals: #(7 4 4 1 2 0) asOrderedCollection.
	self assert: (list partitionIndices) equals: expected.
	self assert: (list outOfPlaceList) equals: #() asOrderedCollection. ! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 12:15:43.27'!
testPartitions
	| list expected |
	list := S2List new.
	list setupList: #(7 4 2 0) asOrderedCollection.
	list partitionIndices: #() asOrderedCollection.
	list partitionIndices add: #(1 2) asOrderedCollection.
	list partitionIndices add: #(3 4) asOrderedCollection.
	expected := #() asOrderedCollection.
	expected add: #(7 4) asOrderedCollection.
	expected add: #(2 0) asOrderedCollection.
	self assert: (list partitions) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 12:03:09.411'!
testSplit1
	| list |
	list := S2List new.
	list setupList: #(1 2 3 4) asOrderedCollection.
	list partitionIndices: #(#(1 2) #(3 4)) asOrderedCollection.
	list splitAfter: 1.
	self assert: (list partitionIndices) equals: #(#(1) #(2) #(3 4)) asOrderedCollection .! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 12:03:11.786'!
testSplit2
	| list |
	list := S2List new.
	list setupList: #(1 2 3 4) asOrderedCollection.
	list partitionIndices: #(#(1) #(2 3 4)) asOrderedCollection.
	list splitAfter: 3.
	self assert: (list partitionIndices) equals: (#(#(1) #(2 3) #(4)) asOrderedCollection).! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 12:03:14.86'!
testSplitAll
	| list |
	list := S2List new.
	list setupList: #(1 2 3 4) asOrderedCollection.
	list partitionIndices: #(#(1 2 3 4)) asOrderedCollection.
	list splitAll.
	self assert: (list partitionIndices) equals: (#(#(1) #(2) #(3) #(4)) asOrderedCollection).! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:52:43.334'!
testSwitchElments
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	expected := #(3 7 8 0 2 0 1 2) asOrderedCollection.
	list switchElementAt: 3 withElementAt: 5.
	self assert: (list elements) equals: expected.! !

TestCase subclass: #S2MergesorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 11:52:37.243'!
testAbortFocusing1
| list iterator |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list partitionIndices: #(#(1 2) #(3 4 5)) asOrderedCollection.
	list activePartitions: #(1 2) asOrderedCollection.
	iterator := S2MergesortIterator newWithList: list.
	self assert: iterator abortFocusing not! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 11:52:39.498'!
testAbortFocusing2
| list iterator |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list partitionIndices: #(#() #() #(5)) asOrderedCollection.
	list activePartitions: #(1 2) asOrderedCollection.
	iterator := S2MergesortIterator newWithList: list.
	self assert: iterator abortFocusing! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 23:32:28.53'!
testFindFirstActivePartition
	| list sublistFinder |
	list := S2List new.
	list setupList: #(7 4 9 2 0) asOrderedCollection.
	list partitionIndices: #() asOrderedCollection.
	list partitionIndices add: #(1 2) asOrderedCollection.
	list partitionIndices add: #(3 4) asOrderedCollection.
	list partitionIndices add: #(5) asOrderedCollection.
	sublistFinder := S2MergesortSublistFinder newWithList: list.
	self assert: (sublistFinder findFirstActivePartition) equals: 1.! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 22:44:35.269'!
testFindFirstActivePartitionOdd
	| list sublistFinder |
	list := S2List new.
	list setupList: #(7 4 9 2 0 1) asOrderedCollection.
	list partitionIndices: #() asOrderedCollection.
	list partitionIndices add: #(1) asOrderedCollection.
	list partitionIndices add: #(2 3) asOrderedCollection.
	list partitionIndices add: #(4 5 6) asOrderedCollection.
	sublistFinder := S2MergesortSublistFinder newWithList: list.
	self assert: (sublistFinder findFirstActivePartition) equals: 1.! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 23:32:45.779'!
testFindSecondActivePartition
	| list sublistFinder |
	list := S2List new.
	list setupList: #(7 4 9 2 0) asOrderedCollection.
	list partitionIndices: #() asOrderedCollection.
	list partitionIndices add: #(1 2) asOrderedCollection.
	list partitionIndices add: #(3 4) asOrderedCollection.
	list partitionIndices add: #(5) asOrderedCollection.
	sublistFinder := S2MergesortSublistFinder newWithList: list.
	self assert: (sublistFinder findSecondActivePartition) equals: 2.! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 23:33:35.948'!
testFindSecondActivePartitionOdd
	| list sublistFinder |
	list := S2List new.
	list setupList: #(7 4 9 2 0 1 5) asOrderedCollection.
	list partitionIndices: #() asOrderedCollection.
	list partitionIndices add: #(1 2 3 4) asOrderedCollection.
	list partitionIndices add: #(5 6) asOrderedCollection.
	list partitionIndices add: #(7) asOrderedCollection.
	sublistFinder := S2MergesortSublistFinder newWithList: list.
	self assert: (sublistFinder findFirstActivePartition) equals: 2.! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 15:10:33.682'!
testSort
|sorter sortedList|
	sorter := S2MergeSorter newWithElements: #(2 5 8 2 6 4 8 2).
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 22:16:48.637'!
testSortEmpty
|sorter sortedList|
	sorter := S2MergeSorter newWithElements: #().
	sortedList := #() asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 22:17:41.279'!
testSortOdd
|sorter sortedList|
	sorter := S2MergeSorter newWithElements: #(4 4 4 4 4).
	sortedList := #(4 4 4 4 4) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

TestCase subclass: #S2QuicksorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksorterTests methodsFor: 'iterating' stamp: 'AT 6/17/2013 18:51:14.3'!
testAbortFocusing1
| list iterator |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 5.
	iterator := S2QuicksortIterator newWithList: list.
	self assert: iterator abortFocusing not! !

!S2QuicksorterTests methodsFor: 'iterating' stamp: 'AT 6/17/2013 18:51:23.746'!
testAbortFocusing2
| list iterator |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 3.
	list secondFocusedIndex: 3.
	iterator := S2QuicksortIterator newWithList: list.
	self assert: iterator abortFocusing! !

!S2QuicksorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/17/2013 18:31:06.724'!
testCompareFocusedElements1
|evaluator list|
	list := S2List new.
	list setupList: #(3 1 2).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	evaluator := S2QuicksortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator compareFocusedElements.
	! !

!S2QuicksorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/17/2013 18:31:13.411'!
testCompareFocusedElements2
|evaluator list|
	list := S2List new.
	list setupList: #(1 2 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	evaluator := S2QuicksortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator compareFocusedElements not.
	! !

!S2QuicksorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/17/2013 18:31:18.908'!
testCompareFocusedElements3
|evaluator list|
	list := S2List new.
	list setupList: #(4 5 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	evaluator := S2QuicksortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator compareFocusedElements not.
	! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:22:47.153'!
testFindLeftIndex1
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3) asOrderedCollection.
	list sortedIndices: #(3) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 1.! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:25:22.583'!
testFindLeftIndex2
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asOrderedCollection.
	list sortedIndices: #(1 2 3 4 5) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: nil.! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:25:27.663'!
testFindLeftIndex3
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asOrderedCollection.
	list sortedIndices: #(2 3 4 5) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 1.! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:25:32.686'!
testFindLeftIndex4
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asOrderedCollection.
	list sortedIndices: #(1 2 4 5) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 3.! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:25:36.905'!
testFindRightIndex1
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asSortedCollection.
	list sortedIndices: #(3) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findRightIndex) equals: 2! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:25:41.698'!
testFindRightIndex2
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asSortedCollection.
	list sortedIndices: #(1 2 3 4 5) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findRightIndex) equals: nil! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:25:47.003'!
testFindRightIndex3
|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asSortedCollection.
	list sortedIndices: #(1 2 3 4) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findRightIndex) equals: 5! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:40:59.029'!
testInitPivotIndex
|finder list|
	list := S2List new.
	list setupList: #(3 1 6 4 7 2) asOrderedCollection.
	list leftBoundIndex: 1.
	list rightBoundIndex: 6.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	self assert: (finder initPivotIndex) equals: 6.! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:41:22.439'!
testInitSecondFocusedIndex
|finder list|
	list := S2List new.
	list setupList: #(3 1 6 4 7 2) asOrderedCollection.
	list leftBoundIndex: 1.
	list rightBoundIndex: 6.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	self assert: (finder initSecondFocusedIndex) equals: 5.! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:34:34.625'!
testNextFocus1
| finder list |
	list := S2List new.
	list setupList: #(2 5 0 3 4 1 6 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 7.
	list pivotIndex: 8.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	finder nextFocusedElementsIndices.
	self assert: (list firstFocusedIndex) equals: 2.
	self assert: (list secondFocusedIndex) equals: 7.
	! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:34:52.643'!
testNextFocus2
| finder list |
	list := S2List new.
	list setupList: #(2 5 0 3 4 1 6 3).
	list firstFocusedIndex: 2.
	list secondFocusedIndex: 7.
	list pivotIndex: 8.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	finder nextFocusedElementsIndices.
	self assert: (list firstFocusedIndex) equals: 2.
	self assert: (list secondFocusedIndex) equals: 6.
	! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:39:16.031'!
testShouldUpdateFirstFocusedIndex
| finder list |
	list := S2List new.
	list setupList: #(1 2 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	finder shouldUpdateFirstFocusedIndex.
	self assert: (finder shouldUpdateFirstFocusedIndex).
	! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:40:13.178'!
testShouldUpdateSecondFocusedIndex
| finder list |
	list := S2List new.
	list setupList: #(1 3 2).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	finder shouldUpdateFirstFocusedIndex.
	self assert: (finder shouldUpdateSecondFocusedIndex).
	! !

!S2QuicksorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 16:53:03.894'!
testSort
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #(2 5 8 2 6 4 8 2).
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:42:37.514'!
testSortAllEqual
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #(2 2 2 2).
	sortedList := #(2 2 2 2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:42:06.339'!
testSortEmpty
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #().
	sortedList := #() asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:42:18.016'!
testSortOne
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #(2).
	sortedList := #(2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'list part sorting' stamp: 'AT 6/24/2013 11:43:35.661'!
testUpdatePivotPosition
	| list partSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 3.
	list pivotIndex: 5.
	partSorter := S2QuicksortSublistSorter newWithList: list.
	partSorter updatePivotPosition.
	self assert: (list elements) equals: #(2 8 2 4 6) asOrderedCollection.! !

!S2QuicksorterTests methodsFor: 'list part sorting' stamp: 'AT 6/24/2013 11:43:38.67'!
testUpdateSortedIndices
	| list partSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list sortedIndices: #() asSortedCollection.
	list pivotIndex: 5.
	partSorter := S2QuicksortSublistSorter newWithList: list.
	partSorter updateSortedIndices.
	self assert: (list sortedIndices) equals: (#(5) asSortedCollection).! !
